
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000251=
{ /*reference*/     "lcrzoex", 251,
  /*version*/       1, 0,
  /*title*/         "tcp ping",
  /*french title*/  "ping tcp",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "ipaddress port",
  /*french usage*/  "adresseip port",
  /*usage example*/ "1.2.3.4 80",
  /*fr. usage ex.*/ "1.2.3.4 80",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000251_main(int argc, char *argv[]);
int lcrzoex_000250_tcpping(lcrzo_device device,
			   lcrzo_etha clientetha,
			   lcrzo_etha routeretha,
			   lcrzo_ipl clientipl, 
			   lcrzo_ipl serveripl, 
			   lcrzo_uint16 serverport);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000251_main(int argc, char *argv[])
{ lcrzo_device device;
  lcrzo_etha clientetha, routeretha;
  lcrzo_ipl clientipl, serveripl;
  lcrzo_uint16 serverport;

  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000251, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }
  lcrzo_epr(lcrzo_ipl_init_hs(argv[1], &serveripl));
  serverport=(lcrzo_uint16)atoi(argv[2]);

  /* get necessary addresses */
  lcrzo_epr(lcrzo_conf_route_to_host(serveripl,
				     device, clientetha, routeretha,
				     &clientipl, NULL));

  /* call the main function */
  lcrzo_epr(lcrzoex_000250_tcpping(device, clientetha, routeretha,
				   clientipl, serveripl, serverport));

  return (LCRZO_ERR_OK);
}



