
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000253=
{ /*reference*/     "lcrzoex", 253,
  /*version*/       1, 0,
  /*title*/         "scan of IP range, for TCP port range",
  /*french title*/  "scan d'une plage IP, pour une plage de ports TCP",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "dstiprange dstportrange",
  /*french usage*/  "plageipdst plageportdst",
  /*usage example*/ "5.6.7.0/24 1-120",
  /*fr. usage ex.*/ "5.6.7.0/24 1-120",
  /*author*/        "Laurent"
};


/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000253_main(int argc, char *argv[]);
int lcrzoex_000252_scaniptcp(lcrzo_device device,
			     lcrzo_etha clientetha,
			     lcrzo_ipl clientipl, 
			     lcrzo_iprange iprange, 
			     lcrzo_portrange portrange);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000253_main(int argc, char *argv[])
{ lcrzo_device device;
  lcrzo_etha clientetha;
  lcrzo_ipl clientipl, serveriplinf, serveriplsup, serverip;
  lcrzo_iprange iprange;
  lcrzo_portrange portrange;
  int ret;

  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000253, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }
  lcrzo_epr(lcrzo_string_init_text(argv[1], LCRZO_IPRANGE_MAXBYTES, iprange));
  lcrzo_epr(lcrzo_string_init_text(argv[2], LCRZO_PORTRANGE_MAXBYTES,
				   portrange));

  /* get necessary addresses */
  lcrzo_epr(lcrzo_ipl_init_iprange(iprange, &serveriplinf, &serveriplsup));
  for ( serverip=serveriplinf ; serverip<=serveriplsup ; serverip++ )
  { ret=lcrzo_conf_route_to_host(serverip, device, clientetha, NULL,
				 &clientipl, NULL);
    if (ret==LCRZO_ERR_OK) break;
    lcrzo_ipl_print("", serverip, " : ");
    lcrzo_err_print(ret);
  }

  /* call the main function */
  lcrzo_epr(lcrzoex_000252_scaniptcp(device, clientetha, clientipl,
				     iprange, portrange));

  return (LCRZO_ERR_OK);
}

