
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_smtp.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000262=
{ /*reference*/     "lcrzoex", 262,
  /*version*/       1, 0,
  /*title*/         "real tcp client [send spoofed email with attachment]",
  /*french title*/  "client tcp reel [envoie email spoofe avec attachement]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port 'mailfrom@a.b' 'rcptto@c.d' 'from@a.b' 'replyto@e.f' 'to@c.d' body_filename attach_filename ['subject']",
  /*french usage*/  "nom_serveur port_serveur 'mailfrom@a.b' 'rcptto@c.d' 'from@a.b' 'replyto@e.f' 'to@c.d' fichier_body fichier_attache ['sujet']",
  /*usage example*/ "1.2.3.4 25 'laurent@s.com' 'dest@d.com' 'laur@s.com' 'l@s.com' 'dest@d.com' /tmp/file /tmp/file2 'here the subject'",
  /*fr. usage ex.*/ "1.2.3.4 25 'laurent@s.com' 'dest@d.com' 'laur@s.com' 'l@s.com' 'dest@d.com' /tmp/fichier /tmp/fichier2 'ici, le sujet'",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000262_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000262_main(int argc, char *argv[])
{ lcrzo_ipl ipl;

  if ( argc<10 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000262, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  lcrzo_er(lcrzo_ipl_init_hs(argv[1], &ipl));
  lcrzo_er(shared_smtp_sendmsg_mp_2files(ipl, (lcrzo_uint16)atoi(argv[2]),
					 argv[3], argv[4], argv[5], argv[6],
					 argv[7],
					 (argc==10)?"":argv[10],
					 argv[8], argv[9]));

  return(LCRZO_ERR_OK);
}


