
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_nntp.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000263=
{ /*reference*/     "lcrzoex", 263,
  /*version*/       1, 0,
  /*title*/         "real tcp client [send newsgroup message with attachment]",
  /*french title*/  "client tcp reel [envoi une message de newsgroup avec attachement]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port 'from@a.b' 'newsgroup' body_filename attachement_filename ['subject']",
  /*french usage*/  "nom_serveur port_serveur  'from@a.b' 'newgroup' fichier_body fichier_attache ['sujet']",
  /*usage example*/ "1.2.3.4 119 'laurent@s.com' 'alt.test' /tmp/file /tmp/attach 'here the subject'",
  /*fr. usage ex.*/ "1.2.3.4 119 'laurent@s.com' 'alt.test' /tmp/fichier /tmp/attache 'ici, le sujet'",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000263_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000263_main(int argc, char *argv[])
{ lcrzo_ipl ipl;

  if ( argc<7 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000263, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  lcrzo_er(lcrzo_ipl_init_hs(argv[1], &ipl));
  lcrzo_er(shared_nntp_sendmsg_mp_2files(ipl, (lcrzo_uint16)atoi(argv[2]),
					 argv[3], argv[3], argv[4], 
					 (argc==7)?"":argv[7], 
					 argv[5], argv[6]));

  return(LCRZO_ERR_OK);
}




