
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_nntp.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000265=
{ /*reference*/     "lcrzoex", 265,
  /*version*/       1, 0,
  /*title*/         "real tcp client [list newsserver groups]",
  /*french title*/  "client tcp reel [liste les groupes d'un serveur]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port",
  /*french usage*/  "nom_serveur port_serveur",
  /*usage example*/ "1.2.3.4 119",
  /*fr. usage ex.*/ "1.2.3.4 119",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000265_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000265_main(int argc, char *argv[])
{ lcrzo_ipl ipl;
  lcrzo_uint16 port;
  lcrzo_list list;
  lcrzo_int32 count, i;
  shared_nntp_list_newsgroups snln;

  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000265, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  lcrzo_epr(lcrzo_ipl_init_hs(argv[1], &ipl));
  lcrzo_epr(lcrzo_uint16_init_text(argv[2], &port));

  lcrzo_epr(shared_nntp_list_init_newsgroups(ipl, port, &list));
  lcrzo_epr(lcrzo_list_count(&list, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_epr(lcrzo_list_value_pos(&list, i, &snln));
    printf("%s [%lu-%lu] %d\n", snln.name, snln.numberfirst, snln.numberlast,
	   snln.canpost);
  }

  lcrzo_epr(lcrzo_list_close(&list));

  return(LCRZO_ERR_OK);
}


