/*
		                  LCRZO
                             Network library
             Copyright(c) 1999,2000,2001, Laurent Constantin
                                  -----

  Main server    : http://www.laurentconstantin.com/
  Backup servers : http://laurentconstantin.free.fr/
                   http://go.to/laurentconstantin/
                   http://laurentconstantin.est-la.com/
                   http://laurentconstantin.ctw.net/
  [my current email address is on the web servers]

                                  -----
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details (http://www.gnu.org).

------------------------------------------------------------------------
*/

#include <lcrzo.h>
#include "lcrzoex.h"

/*---------------------------------------------------------------*/
/* include all the example code we need */
#include "lcrzoex_000251.c"
#include "lcrzoex_000252.c"
#include "lcrzoex_000253.c"
#include "lcrzoex_000254.c"
#include "lcrzoex_000255.c"
#include "lcrzoex_000256.c"
#include "lcrzoex_000257.c"
#include "lcrzoex_000258.c"
#include "lcrzoex_000259.c"
#include "lcrzoex_000260.c"
#include "lcrzoex_000261.c"
#include "lcrzoex_000262.c"
#include "lcrzoex_000263.c"
#include "lcrzoex_000264.c"
#include "lcrzoex_000265.c"
#include "lcrzoex_000266.c"
#include "lcrzoex_000267.c"

/*---------------------------------------------------------------*/
int lcrzoex__00006_main(int ac, char* av[], int exnumber)
{ int language;

  switch (exnumber)
  { 
    case   251 : lcrzo_epr(lcrzoex_000251_main(ac, av)); break;
    case   252 : lcrzo_epr(lcrzoex_000252_main(ac, av)); break;
    case   253 : lcrzo_epr(lcrzoex_000253_main(ac, av)); break;
    case   254 : lcrzo_epr(lcrzoex_000254_main(ac, av)); break;
    case   255 : lcrzo_epr(lcrzoex_000255_main(ac, av)); break;
    case   256 : lcrzo_epr(lcrzoex_000256_main(ac, av)); break;
    case   257 : lcrzo_epr(lcrzoex_000257_main(ac, av)); break;
    case   258 : lcrzo_epr(lcrzoex_000258_main(ac, av)); break;
    case   259 : lcrzo_epr(lcrzoex_000259_main(ac, av)); break;
    case   260 : lcrzo_epr(lcrzoex_000260_main(ac, av)); break;
    case   261 : lcrzo_epr(lcrzoex_000261_main(ac, av)); break;
    case   262 : lcrzo_epr(lcrzoex_000262_main(ac, av)); break;
    case   263 : lcrzo_epr(lcrzoex_000263_main(ac, av)); break;
    case   264 : lcrzo_epr(lcrzoex_000264_main(ac, av)); break;
    case   265 : lcrzo_epr(lcrzoex_000265_main(ac, av)); break;
    case   266 : lcrzo_epr(lcrzoex_000266_main(ac, av)); break;
    case   267 : lcrzo_epr(lcrzoex_000267_main(ac, av)); break;
    default :
      /* get the current language */
      lcrzo_epr(lcrzo_global_get_language(&language));
      if ( language==LCRZO_GLOBAL_FRLANG )
      { printf("Choix '%d' inconnu.\n", exnumber);
        printf("L'exemple numero %d est peut etre disponible ", exnumber); 
        printf("dans une version recente de lcrzo.\n"); 
      }
      else
      { printf("Choice '%d' unknown.\n", exnumber);
        printf("Example number %d is prehaps only available ", exnumber); 
        printf("in a newer version of lcrzo.\n"); 
      }
      lcrzo_epr(lcrzo_libinfos_print());
  }

  return(LCRZO_ERR_OK);
}

/*---------------------------------------------------------------*/
int lcrzoex__00006_infos_print(lcrzo_conststring pn, int exnumber)
{ int language;

  switch (exnumber)
  { 
    case  251 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000251, pn)); break;
    case  252 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000252, pn)); break;
    case  253 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000253, pn)); break;
    case  254 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000254, pn)); break;
    case  255 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000255, pn)); break;
    case  256 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000256, pn)); break;
    case  257 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000257, pn)); break;
    case  258 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000258, pn)); break;
    case  259 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000259, pn)); break;
    case  260 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000260, pn)); break;
    case  261 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000261, pn)); break;
    case  262 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000262, pn)); break;
    case  263 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000263, pn)); break;
    case  264 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000264, pn)); break;
    case  265 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000265, pn)); break;
    case  266 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000266, pn)); break;
    case  267 : lcrzo_epr(lcrzoex_infos_print(lcrzoex_000267, pn)); break;
    default :
      /* get the current language */
      lcrzo_epr(lcrzo_global_get_language(&language));
      if ( language==LCRZO_GLOBAL_FRLANG )
      { printf("Choix '%d' inconnu.\n", exnumber);
        printf("L'exemple numero %d est peut etre disponible ", exnumber); 
        printf("dans une version recente de lcrzo.\n"); 
      }
      else
      { printf("Choice '%d' unknown.\n", exnumber);
        printf("Example number %d is prehaps only available ", exnumber); 
        printf("in a newer version of lcrzo.\n"); 
      }
      lcrzo_epr(lcrzo_libinfos_print());
  }

  return(LCRZO_ERR_OK);
}
