#include <lcrzo.h>
#include "../lcrzoex.h"
#include "shared_misc.h"
#include "shared_smtp.h"


/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_msgid(lcrzo_string *poutput)
{ lcrzo_uint32 r;

  lcrzo_epr(lcrzo_string_appendm_text("Message-ID: <", poutput));
  lcrzo_epr(lcrzo_uint32_rand(0, 0xFFFFFFFFu, &r));
  lcrzo_epr(lcrzo_string_appendm_int(r, "%08X", poutput));
  lcrzo_epr(lcrzo_string_appendm_char('.', 1, poutput));
  lcrzo_epr(lcrzo_uint32_rand(0, 0xFFFFFFFFu, &r));
  lcrzo_epr(lcrzo_string_appendm_int(r, "%08X", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("@domain.com>\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_date(lcrzo_string *poutput)
{ char thedate[80];
  time_t thetime;

  lcrzo_epr(lcrzo_string_appendm_text("Date: ", poutput));
  thetime=time(NULL);
  strftime(thedate, 79, "%a, %d %b %Y %H:%M:%S %z", localtime(&thetime));
  lcrzo_epr(lcrzo_string_appendm_text(thedate, poutput));
  lcrzo_epr(lcrzo_string_appendm_text("\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_from(lcrzo_conststring username,
				  lcrzo_conststring email,
				  lcrzo_string *poutput)
{
  lcrzo_epr(lcrzo_string_appendm_text("From: \"", poutput));
  lcrzo_epr(lcrzo_string_appendm_text(username, poutput));
  lcrzo_epr(lcrzo_string_appendm_text("\" <", poutput));
  lcrzo_epr(lcrzo_string_appendm_text(email, poutput));
  lcrzo_epr(lcrzo_string_appendm_text(">\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_replyto(lcrzo_conststring username,
				     lcrzo_conststring email,
				     lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("Reply-To: \"", poutput));
  lcrzo_epr(lcrzo_string_appendm_text(username, poutput));
  lcrzo_epr(lcrzo_string_appendm_text("\" <", poutput));
  lcrzo_epr(lcrzo_string_appendm_text(email, poutput));
  lcrzo_epr(lcrzo_string_appendm_text(">\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_to(lcrzo_conststring username,
				lcrzo_conststring email,
				lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("To: \"", poutput));
  lcrzo_epr(lcrzo_string_appendm_text(username, poutput));
  lcrzo_epr(lcrzo_string_appendm_text("\" <", poutput));
  lcrzo_epr(lcrzo_string_appendm_text(email, poutput));
  lcrzo_epr(lcrzo_string_appendm_text(">\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_organization(lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("Organization: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("LCRZO LCRZOEX\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_xmailer(lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("X-Mailer: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("Lcrzoex Mailer\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_xacclang(lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("X-Accept-Language: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("en\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_mimeversion(lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("MIME-Version: 1.0\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_conttype_mpmixed(lcrzo_conststring boundary,
					      lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("Content-Type: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("multipart/mixed;\r\n", poutput));
  lcrzo_epr(lcrzo_string_appendm_text(" boundary=\"", poutput));
  lcrzo_epr(lcrzo_string_appendm_text(boundary, poutput));
  lcrzo_epr(lcrzo_string_appendm_text("\"\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_conttype_textplainusascii(lcrzo_conststring name,
						       lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("Content-Type: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("text/plain; charset=us-ascii",poutput));
  if (name!=NULL)
  { lcrzo_epr(lcrzo_string_appendm_text(";\r\n",  poutput));
    lcrzo_epr(lcrzo_string_appendm_text(" name=\"", poutput));
    lcrzo_epr(lcrzo_string_appendm_text(name, poutput));
    lcrzo_epr(lcrzo_string_appendm_text("\"", poutput));
  }
  lcrzo_epr(lcrzo_string_appendm_text("\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_conttype_textplainiso8859(lcrzo_conststring name,
						       lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("Content-Type: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("text/plain; charset=iso-8859-1", 
				      poutput));
  if (name!=NULL)
  { lcrzo_epr(lcrzo_string_appendm_text(";\r\n",  poutput));
    lcrzo_epr(lcrzo_string_appendm_text(" name=\"", poutput));
    lcrzo_epr(lcrzo_string_appendm_text(name, poutput));
    lcrzo_epr(lcrzo_string_appendm_text("\"", poutput));
  }
  lcrzo_epr(lcrzo_string_appendm_text("\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_conttype_appoctstream(lcrzo_conststring name,
						   lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("Content-Type: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("application/octet-stream", 
				      poutput));
  if (name!=NULL)
  { lcrzo_epr(lcrzo_string_appendm_text(";\r\n",  poutput));
    lcrzo_epr(lcrzo_string_appendm_text(" name=\"", poutput));
    lcrzo_epr(lcrzo_string_appendm_text(name, poutput));
    lcrzo_epr(lcrzo_string_appendm_text("\"", poutput));
  }
  lcrzo_epr(lcrzo_string_appendm_text("\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_cte_7bit(lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("Content-Transfer-Encoding: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("7bit\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_cte_8bit(lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("Content-Transfer-Encoding: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("8bit\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_cte_base64(lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("Content-Transfer-Encoding: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("base64\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_contdisp_inline(lcrzo_conststring filename,
					     lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("Content-Disposition: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("inline", 
				      poutput));
  if (filename!=NULL)
  { lcrzo_epr(lcrzo_string_appendm_text(";\r\n",  poutput));
    lcrzo_epr(lcrzo_string_appendm_text(" filename=\"", poutput));
    lcrzo_epr(lcrzo_string_appendm_text(filename, poutput));
    lcrzo_epr(lcrzo_string_appendm_text("\"", poutput));
  }
  lcrzo_epr(lcrzo_string_appendm_text("\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_contdisp_attach(lcrzo_conststring filename,
					     lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("Content-Disposition: ", poutput));
  lcrzo_epr(lcrzo_string_appendm_text("attachment", poutput));
  if (filename!=NULL)
  { lcrzo_epr(lcrzo_string_appendm_text(";\r\n",  poutput));
    lcrzo_epr(lcrzo_string_appendm_text(" filename=\"", poutput));
    lcrzo_epr(lcrzo_string_appendm_text(filename, poutput));
    lcrzo_epr(lcrzo_string_appendm_text("\"", poutput));
  }
  lcrzo_epr(lcrzo_string_appendm_text("\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_empty(lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text("\r\n", poutput));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_subject(lcrzo_conststring subject, 
				     lcrzo_string *poutput)
{ int i;
  lcrzo_uint8 c;
  lcrzo_bool specialcharfound;
  lcrzo_string thesubject;

  specialcharfound=LCRZO_FALSE;
  lcrzo_epr(lcrzo_string_initm_text("Subject: =?iso-8859-1?Q?", &thesubject));
  for ( i=0 ; i<(int)strlen(subject) ; i++ )
  { c=subject[i];
    if ( c<32 || c>=127 )
    { specialcharfound=LCRZO_TRUE;
      lcrzo_epr(lcrzo_string_appendm_text("=", &thesubject));
      lcrzo_epr(lcrzo_string_appendm_int(c, "%02X", &thesubject));
    }
    else
    { lcrzo_epr(lcrzo_string_appendm_char(c, 1, &thesubject));
    }
  }
  lcrzo_epr(lcrzo_string_appendm_text("?=\r\n", &thesubject));

  if (!specialcharfound)
  { lcrzo_string_free(thesubject);
    lcrzo_epr(lcrzo_string_appendm_text("Subject: ", poutput));
    lcrzo_epr(lcrzo_string_appendm_text(subject, poutput));
    lcrzo_epr(lcrzo_string_appendm_text("\r\n", poutput));
  }
  else
  { lcrzo_epr(lcrzo_string_appendm_text(thesubject, poutput));
    lcrzo_string_free(thesubject);  
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_boundary(lcrzo_conststring boundary,
				      lcrzo_string *poutput)
{ lcrzo_epr(lcrzo_string_appendm_text(boundary, poutput));
  lcrzo_epr(lcrzo_string_appendm_text("\r\n", poutput));
  return(LCRZO_ERR_OK);
}


/*-------------------------------------------------------------*/
int shared_smtp_generateboundary(lcrzo_string *pboundary)
{ lcrzo_uint32 r;

  lcrzo_epr(lcrzo_string_initm_text("------------", pboundary));
  lcrzo_epr(lcrzo_uint32_rand(0, 0xFFFFFFFFu, &r));
  lcrzo_epr(lcrzo_string_appendm_int(r, "%08X", pboundary));
  lcrzo_epr(lcrzo_uint32_rand(0, 0xFFFFFFFFu, &r));
  lcrzo_epr(lcrzo_string_appendm_int(r, "%08X", pboundary));
  lcrzo_epr(lcrzo_uint32_rand(0, 0xFFFFFFFFu, &r));
  lcrzo_epr(lcrzo_string_appendm_int(r, "%08X", pboundary));

  return(LCRZO_ERR_OK);
}


/*-------------------------------------------------------------*/
int shared_smtp_initm_headerbody_usascii(lcrzo_conststring from,
					 lcrzo_conststring replyto,
					 lcrzo_conststring to,
					 lcrzo_conststring subject, 
					 lcrzo_constdata bodydata,
					 lcrzo_int32 bodydatasize,
					 lcrzo_data *pdataout,
					 lcrzo_int32 *pdataoutsize)
{ lcrzo_int32 datasize;
  lcrzo_string header;

  /* generate the header */
  lcrzo_epr(lcrzo_string_initm_text("", &header));
  lcrzo_epr(shared_smtp_appendm_line_msgid(&header));
  lcrzo_epr(shared_smtp_appendm_line_date(&header));
  lcrzo_epr(shared_smtp_appendm_line_from(from, from, &header));
  if ( strcmp(from, replyto) )
  { lcrzo_epr(shared_smtp_appendm_line_replyto(replyto, replyto, &header));
  }
  lcrzo_epr(shared_smtp_appendm_line_organization(&header));
  lcrzo_epr(shared_smtp_appendm_line_xmailer(&header));
  lcrzo_epr(shared_smtp_appendm_line_xacclang(&header));
  lcrzo_epr(shared_smtp_appendm_line_to(to, to, &header));
  lcrzo_epr(shared_smtp_appendm_line_subject(subject, &header));
  lcrzo_epr(shared_smtp_appendm_line_empty(&header));

  /* append the data */
  lcrzo_epr(lcrzo_data_initm_text(header, pdataout, &datasize));
  lcrzo_epr(lcrzo_string_free(header));
  lcrzo_epr(lcrzo_data_appendm_data(bodydata, bodydatasize,
				    datasize, pdataout, &datasize));

  /* end */
  if (pdataoutsize!=NULL) *pdataoutsize=datasize;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_initm_headerbody_iso8859(lcrzo_conststring from,
					 lcrzo_conststring replyto,
					 lcrzo_conststring to,
					 lcrzo_conststring subject, 
					 lcrzo_constdata bodydata,
					 lcrzo_int32 bodydatasize,
					 lcrzo_data *pdataout,
					 lcrzo_int32 *pdataoutsize)
{ lcrzo_int32 datasize;
  lcrzo_string header;

  /* generate the header */
  lcrzo_epr(lcrzo_string_initm_text("", &header));
  lcrzo_epr(shared_smtp_appendm_line_msgid(&header));
  lcrzo_epr(shared_smtp_appendm_line_date(&header));
  lcrzo_epr(shared_smtp_appendm_line_from(from, from, &header));
  if ( strcmp(from, replyto) )
  { lcrzo_epr(shared_smtp_appendm_line_replyto(replyto, replyto, &header));
  }
  lcrzo_epr(shared_smtp_appendm_line_organization(&header));
  lcrzo_epr(shared_smtp_appendm_line_xmailer(&header));
  lcrzo_epr(shared_smtp_appendm_line_xacclang(&header));
  lcrzo_epr(shared_smtp_appendm_line_mimeversion(&header));
  lcrzo_epr(shared_smtp_appendm_line_to(to, to, &header));
  lcrzo_epr(shared_smtp_appendm_line_subject(subject, &header));
  lcrzo_epr(shared_smtp_appendm_line_conttype_textplainiso8859(NULL, &header));
  lcrzo_epr(shared_smtp_appendm_line_cte_8bit(&header));
  lcrzo_epr(shared_smtp_appendm_line_empty(&header));

  /* append the data */
  lcrzo_epr(lcrzo_data_initm_text(header, pdataout, &datasize));
  lcrzo_epr(lcrzo_string_free(header));
  lcrzo_epr(lcrzo_data_appendm_data(bodydata, bodydatasize,
				    datasize, pdataout, &datasize));

  /* end */
  if (pdataoutsize!=NULL) *pdataoutsize=datasize;
  return(LCRZO_ERR_OK);
}


/*-------------------------------------------------------------*/
int shared_smtp_initm_multipart_header(lcrzo_conststring from,
				       lcrzo_conststring replyto,
				       lcrzo_conststring to,
				       lcrzo_conststring subject, 
				       lcrzo_string *pboundary,
				       lcrzo_data *pdataout,
				       lcrzo_int32 *pdataoutsize)
{ lcrzo_string header;

  lcrzo_epr(shared_smtp_generateboundary(pboundary));

  /* generate the header */
  lcrzo_epr(lcrzo_string_initm_text("", &header));
  lcrzo_epr(shared_smtp_appendm_line_msgid(&header));
  lcrzo_epr(shared_smtp_appendm_line_date(&header));
  lcrzo_epr(shared_smtp_appendm_line_from(from, from, &header));
  if ( strcmp(from, replyto) )
  { lcrzo_epr(shared_smtp_appendm_line_replyto(replyto, replyto, &header));
  }
  lcrzo_epr(shared_smtp_appendm_line_organization(&header));
  lcrzo_epr(shared_smtp_appendm_line_xmailer(&header));
  lcrzo_epr(shared_smtp_appendm_line_xacclang(&header));
  lcrzo_epr(shared_smtp_appendm_line_mimeversion(&header));
  lcrzo_epr(shared_smtp_appendm_line_to(to, to, &header));
  lcrzo_epr(shared_smtp_appendm_line_subject(subject, &header));
  lcrzo_epr(shared_smtp_appendm_line_conttype_mpmixed(*pboundary, &header));
  lcrzo_epr(shared_smtp_appendm_line_empty(&header));

  /* append the data */
  lcrzo_epr(lcrzo_string_appendm_text(
        "This is a multi-part message in MIME format.\r\n", &header));

  /* generate output data */
  lcrzo_epr(lcrzo_data_initm_text(header, pdataout, pdataoutsize));
  lcrzo_epr(lcrzo_string_free(header));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_multipart_usascii(lcrzo_conststring boundary,
					  lcrzo_conststring headername,
					  lcrzo_conststring headerfilename,
					  lcrzo_constdata data,
					  lcrzo_int32 datasize,
					  lcrzo_int32 dataoutcurrentsize,
					  lcrzo_data *pdataout,
					  lcrzo_int32 *pdataoutsize)
{ lcrzo_int32 dataoutsize;
  lcrzo_string header;

  /* generate the header */
  lcrzo_epr(lcrzo_string_initm_text("--", &header));
  lcrzo_epr(shared_smtp_appendm_line_boundary(boundary, &header));
  lcrzo_epr(shared_smtp_appendm_line_conttype_textplainusascii(headername, 
							       &header));
  lcrzo_epr(shared_smtp_appendm_line_cte_7bit(&header));
  lcrzo_epr(shared_smtp_appendm_line_contdisp_inline(headerfilename, 
						     &header));
  lcrzo_epr(shared_smtp_appendm_line_empty(&header));

  /* append the data */
  lcrzo_epr(lcrzo_data_appendm_text(header, dataoutcurrentsize, 
				    pdataout, &dataoutsize));
  lcrzo_epr(lcrzo_string_free(header));
  lcrzo_epr(lcrzo_data_appendm_data(data, datasize,
				    dataoutsize, pdataout, &dataoutsize));

  /* end */
  if (pdataoutsize!=NULL) *pdataoutsize=dataoutsize;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_multipart_iso8859(lcrzo_conststring boundary,
					  lcrzo_conststring headername,
					  lcrzo_conststring headerfilename,
					  lcrzo_constdata data,
					  lcrzo_int32 datasize,
					  lcrzo_int32 dataoutcurrentsize,
					  lcrzo_data *pdataout,
					  lcrzo_int32 *pdataoutsize)
{ lcrzo_int32 dataoutsize;
  lcrzo_string header;

  /* generate the header */
  lcrzo_epr(lcrzo_string_initm_text("--", &header));
  lcrzo_epr(shared_smtp_appendm_line_boundary(boundary, &header));
  lcrzo_epr(shared_smtp_appendm_line_conttype_textplainiso8859(headername, 
							       &header));
  lcrzo_epr(shared_smtp_appendm_line_cte_8bit(&header));
  lcrzo_epr(shared_smtp_appendm_line_contdisp_inline(headerfilename, 
						     &header));
  lcrzo_epr(shared_smtp_appendm_line_empty(&header));

  /* append the data */
  lcrzo_epr(lcrzo_data_appendm_text(header, dataoutcurrentsize, 
				    pdataout, &dataoutsize));
  lcrzo_epr(lcrzo_string_free(header));
  lcrzo_epr(lcrzo_data_appendm_data(data, datasize,
				    dataoutsize, pdataout, &dataoutsize));

  /* end */
  if (pdataoutsize!=NULL) *pdataoutsize=dataoutsize;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_multipart_base64(lcrzo_conststring boundary,
					 lcrzo_conststring headername,
					 lcrzo_conststring headerfilename,
					 lcrzo_constdata data,
					 lcrzo_int32 datasize,
					 lcrzo_int32 dataoutcurrentsize,
					 lcrzo_data *pdataout,
					 lcrzo_int32 *pdataoutsize)
{ lcrzo_int32 dataoutsize, i, chunknumber, bytesleft;
  lcrzo_string header, base64;

  /* generate the header */
  lcrzo_epr(lcrzo_string_initm_text("--", &header));
  lcrzo_epr(shared_smtp_appendm_line_boundary(boundary, &header));
  lcrzo_epr(shared_smtp_appendm_line_conttype_appoctstream(headername, 
							   &header));
  lcrzo_epr(shared_smtp_appendm_line_cte_base64(&header));
  lcrzo_epr(shared_smtp_appendm_line_contdisp_attach(headerfilename, &header));
  lcrzo_epr(shared_smtp_appendm_line_empty(&header));
  lcrzo_epr(lcrzo_data_appendm_text(header, dataoutcurrentsize, 
				    pdataout, &dataoutsize));
  lcrzo_epr(lcrzo_string_free(header));

  /* append the data */
  chunknumber=datasize/54;
  for ( i=0 ; i<chunknumber ; i++ )
  { lcrzo_epr(lcrzo_base64_initm_data(data+i*54, 54, &base64));
    lcrzo_epr(lcrzo_data_appendm_text(base64, 
				      dataoutsize, pdataout, &dataoutsize));
    lcrzo_epr(lcrzo_string_free(base64));
    lcrzo_epr(lcrzo_data_appendm_text("\r\n", 
				      dataoutsize, pdataout, &dataoutsize));
  }
  bytesleft=datasize-54*chunknumber;
  if (bytesleft)
  { lcrzo_epr(lcrzo_base64_initm_data(data+chunknumber*54, bytesleft,&base64));
    lcrzo_epr(lcrzo_data_appendm_text(base64, 
				      dataoutsize, pdataout, &dataoutsize));
    lcrzo_epr(lcrzo_string_free(base64));
    lcrzo_epr(lcrzo_data_appendm_text("\r\n", 
				      dataoutsize, pdataout, &dataoutsize));
  }
 
  /* end */
  if (pdataoutsize!=NULL) *pdataoutsize=dataoutsize;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_appendm_multipart_end(lcrzo_conststring boundary,
				      lcrzo_int32 dataoutcurrentsize,
				      lcrzo_data *pdataout,
				      lcrzo_int32 *pdataoutsize)
{ lcrzo_int32 dataoutsize;
  lcrzo_string header;

  /* generate the header */
  lcrzo_epr(lcrzo_string_initm_text("--", &header));
  lcrzo_epr(shared_smtp_appendm_line_boundary(boundary, &header));
  lcrzo_epr(lcrzo_string_appendm_text("--\r\n", &header));

  /* append the data */
  lcrzo_epr(lcrzo_data_appendm_text(header, dataoutcurrentsize, 
				    pdataout, &dataoutsize));
  lcrzo_epr(lcrzo_string_free(header));

  /* end */
  if (pdataoutsize!=NULL) *pdataoutsize=dataoutsize;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_sendmsg(lcrzo_ipl serverip, 
			lcrzo_uint16 serverport,
			lcrzo_conststring mailfrom, 
			lcrzo_conststring rcptto,
			lcrzo_constdata headerbody,
			lcrzo_int32 headerbodysize)
{ lcrzo_sock sock;
  lcrzo_data data;
  lcrzo_int32 datasize, foundpositive;
  lcrzo_string domainname;
  int ret;

  /* initialize the client domain name */
  ret=lcrzo_string_search_char(mailfrom, LCRZO_FALSE,
			       +1, -1, '@',
			       NULL, &foundpositive);
  if ( ret==LCRZO_ERR_OK )
  { lcrzo_epr(lcrzo_string_initm_range(mailfrom, foundpositive+1, -1,
				       &domainname));
  }
  else
  { lcrzo_epr(lcrzo_string_initm_text("microsoft.com", &domainname));
  }

  /* initialize the client */
  lcrzo_epr(lcrzo_sock_tcpcli_real(serverip, serverport, &sock));

  /* first, we read the banner */
  lcrzo_epr(shared_misc_verifyresponse1(&sock, 220));

  /* then, we send a 'HELO' */
  lcrzo_epr(lcrzo_data_initm_text("HELO ", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(domainname, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\r\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(&sock, data, datasize));
  lcrzo_string_free(domainname);
  lcrzo_data_free(data);
  lcrzo_epr(shared_misc_verifyresponse1(&sock, 250));

  /* then, we send a 'MAIL FROM' */
  lcrzo_epr(lcrzo_data_initm_text("Mail From: <", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(mailfrom, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(">\r\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(&sock, data, datasize));
  lcrzo_data_free(data);
  lcrzo_epr(shared_misc_verifyresponse1(&sock, 250));

  /* then, we send a 'RCPT TO' */
  lcrzo_epr(lcrzo_data_initm_text("Rcpt to: <", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(rcptto, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(">\r\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(&sock, data, datasize));
  lcrzo_data_free(data);
  lcrzo_epr(shared_misc_verifyresponse1(&sock, 250));

  /* then, we send a 'DATA' */
  lcrzo_epr(lcrzo_data_initm_text("DATA\r\n",
				  &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(&sock, data, datasize));
  lcrzo_data_free(data);
  lcrzo_epr(shared_misc_verifyresponse1(&sock, 354));

  /* then, we send data */
  lcrzo_epr(lcrzo_sock_write(&sock, headerbody, headerbodysize));
  lcrzo_epr(lcrzo_data_initm_text(".\r\n",
				  &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(&sock, data, datasize));
  lcrzo_data_free(data);
  lcrzo_epr(shared_misc_verifyresponse1(&sock, 250));

  /* then, we send a 'QUIT' */
  lcrzo_epr(lcrzo_data_initm_text("QUIT\r\n",
				  &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(&sock, data, datasize));
  lcrzo_data_free(data);
  lcrzo_epr(shared_misc_verifyresponse1(&sock, 221));

  /* close the socket */
  lcrzo_epr(lcrzo_sock_close(&sock));
  return(LCRZO_ERR_OK);
}


/*-------------------------------------------------------------*/
int shared_smtp_initm_subjectdata_file(lcrzo_conststring subject, 
				       lcrzo_conststring bodyfilename,
				       lcrzo_string *psubject, 
				       lcrzo_data *pdata,
				       lcrzo_int32 *pdatasize)
{ lcrzo_int32 linesize, datasize;
  lcrzo_data line;
  int ret, language;
  FILE *stream;

  /* open the file */
  lcrzo_epr(lcrzo_global_get_language(&language));
  lcrzo_epr(lcrzo_stream_open_read(bodyfilename, (LCRZOFILE**)&stream));

  /* eventually get the subject on the first line */
  if ( strlen(subject) )
  { lcrzo_epr(lcrzo_string_initm_text(subject, psubject));
  }
  else
  { /* the subject is on the first line of the file */
    lcrzo_epr(lcrzo_stream_readm_line(stream, LCRZO_TRUE, &line, &linesize));
    line[linesize]='\0';
    lcrzo_epr(lcrzo_string_initm_text(line, psubject));
    lcrzo_data_free(line);
  }

  /* read the data in the file */
  lcrzo_epr(lcrzo_data_initm_text("", pdata, &datasize));
  while(LCRZO_TRUE)
  { ret=lcrzo_stream_readm_line(stream, LCRZO_TRUE, &line, &linesize);
    if (ret==LCRZO_ERR_OKDATAEND)
    { break;
    }
    else if (ret==LCRZO_ERR_OK)
    { if ( linesize>254 )
      { if ( language==LCRZO_GLOBAL_FRLANG )
          printf("La ligne semble trop longue: %ld caracteres\n", linesize); 
        else
          printf("Line seems too long: %ld characters\n", linesize); 
      }
      if ( linesize>0 && line[0]=='.' )
      { lcrzo_epr(lcrzo_data_appendm_char('.', 1, datasize, pdata, &datasize));
      }
      lcrzo_epr(lcrzo_data_appendm_data(line, linesize,
					datasize, pdata, &datasize));
      lcrzo_data_free(line);
      lcrzo_epr(lcrzo_data_appendm_text("\r\n", datasize, pdata, &datasize));
    }
    else
    { lcrzo_stream_close(stream);
      return(ret);
    }
  }
  lcrzo_epr(lcrzo_stream_close(stream));

  /* end */
  if (pdatasize!=NULL) *pdatasize=datasize;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_initm_headerbody_file(lcrzo_conststring from,
				      lcrzo_conststring replyto,
				      lcrzo_conststring to,
				      lcrzo_conststring subject, 
				      lcrzo_conststring bodyfilename,
				      lcrzo_data *pdata,
				      lcrzo_int32 *pdatasize)
{ lcrzo_data bodydata;
  lcrzo_int32 bodydatasize;
  lcrzo_string thesubject;

  lcrzo_epr(shared_smtp_initm_subjectdata_file(subject, bodyfilename,
					       &thesubject,
					       &bodydata, &bodydatasize));

  lcrzo_epr(shared_smtp_initm_headerbody_iso8859(from, replyto, to, 
						 thesubject, 
						 bodydata, bodydatasize,
						 pdata, pdatasize));
  lcrzo_data_free(bodydata);
  lcrzo_string_free(thesubject);
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_initm_multipart_2files(lcrzo_conststring from,
				       lcrzo_conststring replyto,
				       lcrzo_conststring to,
				       lcrzo_conststring subject, 
				       lcrzo_conststring bodyfilename,
				       lcrzo_conststring attachementfilename,
				       lcrzo_data *pdata,
				       lcrzo_int32 *pdatasize)
{ lcrzo_data bodydata;
  lcrzo_int32 bodydatasize, datasize;
  lcrzo_string thesubject, boundary, tmp;

  lcrzo_epr(shared_smtp_initm_subjectdata_file(subject, bodyfilename,
					       &thesubject,
					       &bodydata, &bodydatasize));

  /* header */
  lcrzo_epr(shared_smtp_initm_multipart_header(from, replyto, to, thesubject, 
					       &boundary, pdata, &datasize));
  lcrzo_string_free(thesubject);

  /* first file */
  lcrzo_epr(lcrzo_filename_lastfile(bodyfilename, &tmp));
  lcrzo_epr(shared_smtp_appendm_multipart_iso8859(boundary, tmp, tmp,
						  bodydata, bodydatasize,
						  datasize, pdata, &datasize));
  lcrzo_string_free(tmp);
  lcrzo_data_free(bodydata);

  /* second file */
  lcrzo_epr(lcrzo_file_read(attachementfilename, &bodydata, &bodydatasize));
  lcrzo_epr(lcrzo_filename_lastfile(attachementfilename, &tmp));
  lcrzo_epr(shared_smtp_appendm_multipart_base64(boundary, tmp, tmp,
						 bodydata, bodydatasize,
						 datasize, pdata, &datasize));
  lcrzo_string_free(tmp);
  lcrzo_data_free(bodydata);

  /* end */
  lcrzo_epr(shared_smtp_appendm_multipart_end(boundary, 
					      datasize, pdata, &datasize));

  if (pdatasize!=NULL) *pdatasize=datasize;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_sendmsg_hb_file(lcrzo_ipl serverip, 
				lcrzo_uint16 serverport,
				lcrzo_conststring mailfrom, 
				lcrzo_conststring rcptto,
				lcrzo_conststring from, 
				lcrzo_conststring replyto, 
				lcrzo_conststring to,
				lcrzo_conststring subject, 
				lcrzo_conststring bodyfilename)
{ lcrzo_data headerbody;
  lcrzo_int32 headerbodysize;

  lcrzo_epr(shared_smtp_initm_headerbody_file(from, replyto, to, subject,
					      bodyfilename, &headerbody,
					      &headerbodysize));

  lcrzo_epr(shared_smtp_sendmsg(serverip, serverport, mailfrom, rcptto,
				headerbody, headerbodysize));
  lcrzo_data_free(headerbody);
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_smtp_sendmsg_mp_2files(lcrzo_ipl serverip, 
				  lcrzo_uint16 serverport,
				  lcrzo_conststring mailfrom, 
				  lcrzo_conststring rcptto,
				  lcrzo_conststring from, 
				  lcrzo_conststring replyto, 
				  lcrzo_conststring to,
				  lcrzo_conststring subject, 
				  lcrzo_conststring bodyfilename,
				  lcrzo_conststring attachementfilename)
{ lcrzo_data headerbody;
  lcrzo_int32 headerbodysize;

  lcrzo_epr(shared_smtp_initm_multipart_2files(from, replyto, to, subject,
					       bodyfilename, 
					       attachementfilename,
					       &headerbody,
					       &headerbodysize));

  lcrzo_epr(shared_smtp_sendmsg(serverip, serverport, mailfrom, rcptto,
				headerbody, headerbodysize));
  lcrzo_data_free(headerbody);
  return(LCRZO_ERR_OK);
}
